/*******************************************************************************
 * Licensed Materials - Property of IBM (c) Copyright IBM Corporation 2013. All
 * Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.CreateIterationsDialogPreviewStore"); //$NON-NLS-1$

	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ProcessStore"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;

	/**
	 * This is a special store for preview elements tree in the "create
	 * iterations" dialog. The preview elements in this store are used to
	 * construct new timeline/iterations for project areas.
	 * 
	 * This store was created to replace the TimelineStore, which allows us to
	 * reuse the TimelineModel (used in the Timelines page) as is. The
	 * CreateIterationsDialogPreviewStore defines some functions with the same 
	 * names as those in TimelineStore some of the methods in the
	 * TimelineStore, so that TimelineModel functions properly (when calling
	 * them) in this context.
	 * 
	 */
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.CreateIterationsDialogPreviewStore", com.ibm.team.process.web.ui.internal.admin.projects.ProcessStore, { //$NON-NLS-1$
		/*
		 * Constructs the CreateIterationsDialogPreviewStore store. No special
		 * args are required.
		 */
		constructor: function(args) {
		},

		isArchivedItem: function(item){
			return this.hasAttribute(item, "archived") && this.getValue(item, "archived"); //$NON-NLS-1$	//$NON-NLS-2$	
		},

		isTimeline: function(item) {
			var isTimeline = this.getValue(item, "isTimeline"); //$NON-NLS-1$
			return isTimeline === true;
		},

		isIteration: function(item) {
			return !this.isTimeline(item);
		},

		isNewItem: function(item) {
			var existing = this.getValue(item, "existing"); //$NON-NLS-1$
			return existing === true;
		},

		getEditorContext: function() {
			return ProcessConstants.EditorContext.PROJECT;
		}
	});

})();
