/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.ProcessDescriptionEditor"); //$NON-NLS-1$

	dojo.require("com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$	
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.NavigationData"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.PracticeElement"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ExportDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ImportDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.AbstractPracticesEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeTreePane"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.ProcessDescriptionDetailEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.ProcessDescriptionLanguageDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.SharedPracticeSelectionDialog"); //$NON-NLS-1$

	dojo.require("dijit.layout.AccordionContainer"); //$NON-NLS-1$
	dojo.require("dijit.layout.BorderContainer"); //$NON-NLS-1$
	dojo.require("dijit.layout.ContentPane"); //$NON-NLS-1$
	dojo.require("dijit.Tree"); //$NON-NLS-1$
	
	
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	
	dojo.require("jazz.ui.Toolbar"); //$NON-NLS-1$
	dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$1$
	dojo.require("jazz.ui.toolbar.TwoStateButton"); //$NON-NLS-1$1$

	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$	 
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient;
	var ProcessDescriptionDetailEditor = com.ibm.team.process.authoring.web.common.ui.internal.editors.ProcessDescriptionDetailEditor;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	var PracticeTreePane = com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeTreePane;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	var SharedPracticeSelectionDialog = com.ibm.team.process.authoring.web.common.ui.internal.editors.SharedPracticeSelectionDialog;
	var ProcessDescriptionLanguageDialog = com.ibm.team.process.authoring.web.common.ui.internal.editors.ProcessDescriptionLanguageDialog;
	var PracticeElement = com.ibm.team.process.authoring.web.common.common.internal.PracticeElement;
	var ImportDialog = com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ImportDialog;
	var ExportDialog = com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ExportDialog;
	var NavigationData = com.ibm.team.process.authoring.web.common.common.internal.NavigationData;
	var PROCESS_DESCRIPTION_EDIT_ACTION_PREFIX = "#action=com.ibm.team.process.authoring.editProcessDescription&resource="; //$NON-NLS-1$
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.ProcessDescriptionEditor", [com.ibm.team.process.authoring.web.common.ui.internal.editors.AbstractPracticesEditor], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/ProcessDescriptionEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
		outlinePane: null,
		practicePane: null,
		resourceURL: null,
		processDescriptionId: null,
		processDescriptionName: null,
		processDescriptionLanguage: null,
		processDescriptionOwner: null,
		processDescriptionOwnerName: null,
		processDescription: "", //$NON-NLS-1$
		processDescriptionXML: null,
		processDescriptionETag: null,
		detailEditor: null,
		isShared: false,
		isPLMShared: false,
		breadcrumblink: "#action=com.ibm.team.process.authoring.manageProcessDescriptions", //$NON-NLS-1$
		//constants definition
		TITLE_LABEL: "name", //$NON-NLS-1$
		OWNER_LABEL: "owner", //$NON-NLS-1$
		PLMSHARED_TARGET: "IsPLMShared", //$NON-NLS-1$
		
		DEFAULT_PROCESSDESCRIPTION_OWNERURL: UIHelper.getURLPrefix() + "/process/project-areas/[PROJECTAREA-UUID]", //$NON-NLS-1$
		_initialize: function(arg) {
			this.breadcrumbText = this.messages.ProcessDescriptionEditor_4;
			this.inherited(arguments);
			this.enableLock = window.location.search.toLowerCase().indexOf(ProcessAuthoringConstants.ENABLELOCK) !== -1;
			
			if (arg.resource) {
				this.resourceURL = arg.resource;
				if(arg.practiceUrl){
					this.practiceUrl = arg.practiceUrl;
				}
				if(arg.practiceElementUrl){
					this.practiceElementUrl = arg.practiceElementUrl;
				}
			} else {
				if (arg.ownerURL) {
					this.processDescriptionOwner = arg.ownerURL; 
				}
				this.isNew = true;
			}
			
			this._processDescriptionIconSrc = dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/process_description_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
            this._exportIconSrc = "com.ibm.team.process.authoring.web.common/graphics/icons/export-process-description_co.gif"; //$NON-NLS-1$
            this._editModeIconSrc = "com.ibm.team.process.authoring.web.common/graphics/icons/edit-button.gif"; //$NON-NLS-1$
            this._copyUrlIconSrc = "com.ibm.team.process.authoring.web.common/graphics/icons/copyurl-button.gif"; //$NON-NLS-1$
		},
		
		postCreate: function() {
			this.inherited(arguments);
			this.isFirstLoad = true;
			if (this.viewOnly) {
				dojo.addClass(this.name, "hide"); //$NON-NLS-1$
			} else {
				//for primary field toggling
				this._connectTitleEventHandles();				
				this.connect(this.name, "onblur", function(e) { //$NON-NLS-1$
					this.togglePrimaryField(ProcessAuthoringConstants.EditorMode.PREVIEW);
				});
				
				this.connect(this.name, "onkeyup", "_handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
				this.connect(this.name, "onchange", "_handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
				
				this.editButton.set("pressed", !this.viewMode); //$NON-NLS-1$
			}
			
			//this must be called after layout			
            if (this.isNew) {
            	this._hidePracticeTree();
				this.detailEditor.onSize = dojo.hitch(this, this.resizeEditor);
            	this._toggleHiddenButtons(true) //hide export button
            } else {
				this.displayWaitingMessage(this.messages.ProcessDescriptionEditor_23);
				this._toggleViewEditMode();				
			}
		},
		
		_toggleViewEditMode: function() {
			this.inherited(arguments);
			//in edit mode, disable the outline structure
            if (!this.viewMode && this.outlinePane && !this.outlinePane.disabled) {
            	this.outlinePane.disabled = true;
            	var node = this.processDescriptionTreePane.trees[0].getNodesByItem(this.workingCopy.currentItem);
            	if (node && node[0]) {
            		var isOutlineElement = node[0].item.root ? node[0].item.isOutlineElement : node[0].item._S.getValue(node[0].item, "isOutlineElement"); //$NON-NLS-1$
            	}

				//current element is an element in the outline pane
                if (this.rightContent.currentEditor && isOutlineElement) {
                	var url = node[0].item._S.getValue(node[0].item, "resource"); //$NON-NLS-1$
                	//it's a practice or practice element
                	if (url) {
						if (ProcessAuthoringClient.isPracticeURL(url)) {
							this.workingCopy.currentItem = url;
						} else {
							this.workingCopy.currentItem = url.substring(url.lastIndexOf("/") + 1); //$NON-NLS-1$
						}
                		this.linkAction(url);
                	} else { //category doesn't have url
                		this.leftNavigator.selectChild(this.practicePane);
                	}
                } else {
                	this.leftNavigator.selectChild(this.practicePane);
                }
            } else if (this.viewMode && this.outlinePane) {
            	this.outlinePane.disabled = false;
            }
			
			//toggle view/edit mode in practiceTreePane, target mode is view, hide the action buttons
            if (this.viewToolBar_AddPrivatePracticeButton) {
            	this.viewToolBar_AddPrivatePracticeButton.set("visible", !this.viewMode); //$NON-NLS-1$
				this.viewToolBar_ImportPracticeButton.set("visible", !this.viewMode); //$NON-NLS-1$
			}
			
            if (this.viewToolBar_AddSharedPracticeButton) {
            	this.viewToolBar_AddSharedPracticeButton.set("visible", !this.viewMode); //$NON-NLS-1$
            }
		},
		
		_toggleHiddenButtons: function(isHide) {
			if (this.copyUrlButton) {
				dojo.toggleClass(this.copyUrlButton.domNode, ProcessAuthoringConstants.CSS_HIDE, isHide);
			}
			if (this.exportProcessDescriptionButton) {
				dojo.toggleClass(this.exportProcessDescriptionButton.domNode, ProcessAuthoringConstants.CSS_HIDE, isHide);
			}
		},
		
		/**
         * If the authoring resource url is clicked, try to call _linkAction() to handle it 
         * or subscribe a function when not all the practices are loaded.
         * @param {string} url the resource url.
         */
		linkAction: function(url) {
			if ((ProcessAuthoringClient.isPracticeURL(url) || UIHelper.isPracticeElementURL(url)) && (!this.allPracticesLoaded)) {
				this.locateUrl = url;
				if (this.linkActionHandle) {
					dojo.unsubscribe(this.linkActionHandle);
				}
				//show loading message
				this._showLoadingMessage(this.contentEditor);
				this.linkActionHandle = dojo.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_LINK_ACTION_READY, this, this._linkAction);
			} else {
				this._linkAction(url);
			}
		},
		
        /**
         * Show loading message to replace content editor
         * @param {ContentEditor} contentEditor is a ContentEditor widget.
         */
		_showLoadingMessage: function(contentEditor) {
			if (contentEditor) {
				this.rightContent.set('content', ''); //$NON-NLS-1$ //$NON-NLS-2$
				contentEditor.destroyRecursive();
				
				// show loading message
				var messageBox = new jazz.ui.MessageBox();
				var messageBoxArgs = {};
				messageBoxArgs.summary = this.messages.ProcessDescriptionEditor_23;
				messageBoxArgs.closable = false;
				messageBoxArgs.type = jazz.ui.MessageBox.STATUS_TYPES.INFO;
				messageBox.showMessage(messageBoxArgs);

				var div = document.createElement("div"); //$NON-NLS-1$
			    div.appendChild(messageBox.domNode);
				dojo.style(div, "padding", "15px"); //$NON-NLS-1$ //$NON-NLS-2$
				this.rightContent.set('content', div); //$NON-NLS-1$
			}
		},
		
		_linkAction: function(url) {
			url = UIHelper.removeLangParamFromURL(url);
			var resourceId = url.substring(url.lastIndexOf("/") + 1); //$NON-NLS-1$
			var isInPracticePane = false;
			if (ProcessAuthoringClient.isPracticeURL(url)) { //practices
				if (this.practiceTreePane) {
					this.practiceTreePane.getItem(url, null, dojo.hitch(this, function(item, tree) {
						this.populatePracticeDescription(item, url, tree.viewOnly); //$NON-NLS-1$
						this.practiceTreePane.selectTree(tree);
						var path = this.workingCopy.getNodePath(this.workingCopy.currentItem);
						tree.set("selectedItem", path[0]); //$NON-NLS-1$
						setTimeout(dojo.hitch(this, function() {
		            		tree.set("selectedItem", path[0]); //$NON-NLS-1$
		            	}), 500);
						isInPracticePane = true;
					}));
				}
				if (!isInPracticePane) {
					if (this.confirmNavigate()) {
						window.location.href = url;
					}
				}
			} else if (UIHelper.isPracticeElementURL(url)) { //practice elements
				if (this.practiceTreePane) {
					dojo.some(this.practiceTreePane.trees, function(tree) {
						if (resourceId) {
							tree.model.store.fetchItemByIdentity({
								identity: resourceId,
								onItem: dojo.hitch(this, function(item) {
									if (item) {
										this.populatePracticeElement(item, url, tree.viewOnly);
										this.practiceTreePane.selectTree(tree);
										var path = this.workingCopy.getNodePath(this.workingCopy.currentItem);
										setTimeout(dojo.hitch(this, function() {
						            		tree.set("path", path); //$NON-NLS-1$
						            	}), 500);
										isInPracticePane = true;
										return true;
									}
								})
							});
						}
						return false;
					}, this);
				}
				if (!isInPracticePane) {
					if (this.confirmNavigate()) {
						window.location.href = url;
					}
				}
			} else if (ProcessAuthoringClient.isProcessDescriptionURL(url)) { //descriptions
				if (url !== this.resourceURL) {
					if (this.confirmNavigate()) {
						window.location.href = url;
					}
				} else {
					if (confirm(this.messages.ProcessDescriptionEditor_22) && this.confirmNavigate()) {
						window.location.href = url;
					}
				}
			} else {
				if (this.confirmNavigate()) {
					window.location.href = url;
				}
			}
			
            
            if (isInPracticePane) {
            	this.leftNavigator.selectChild(this.practicePane);
            	setTimeout(dojo.hitch(this, function() {
            		this.container.resize();
            	}), 200);
            }
		},
		
		exportProcessDescription: function(evt) {
			dojo.stopEvent(evt);
			var dialog = new ExportDialog({
				resourceUrl: this.resourceURL,
				message: dojo.string.substitute(this.messages.ProcessDescriptionListPage_16, [UIHelper.escapeXML(this._getProcessDescriptionName())])
			});
		},
		
		handleLock: function(lockRequest, byForce) {
			this._handleLock(lockRequest, byForce, false);
		},
		
		initTreePane: function() {
			this.practicePane = new dijit.layout.ContentPane({
				title: this.messages.ProcessDescriptionEditor_5,
				selected: "true" //$NON-NLS-1$
			}, document.createElement("DIV")); //$NON-NLS-1$
			this.leftNavigator.addChild(this.practicePane);
			
			if (this.isNew === true) {
				this._showUIForCreation();
			} else {
				this._showUIForEditing();
			}
		},
		
		switchLanguage: function(evt) {
			dojo.stopEvent(evt);
			var languageDialog = new ProcessDescriptionLanguageDialog({
				controller: this,
				resource: this.resourceURL,
				owner: this._getOwner(),
				viewOnly: this.viewOnly,
				workingCopy: this.workingCopy
			});
		},
		
		_showUIForCreation: function() {
			//setup detail field
			this._createDetailEditor(this.isShared);
			if ( this.isShared ) {
				this.detailEditor.sharingCheckType = ProcessAuthoringConstants.DETAILEDITOR_CHECKBOXTYPE_UNCHECKED;
			}
			this.detailWrapper.appendChild(this.detailEditor.domNode);
			this.resetAllFields();
			this.togglePrimaryField(ProcessAuthoringConstants.EditorMode.EDIT);
		},
		
		_showUIForEditing: function() {
			this.isRefreshCalled = false; 
			this.loadData();
		},
		
		_hidePracticeTree: function() {
			dojo.toggleClass(this.contentWrapper, ProcessAuthoringConstants.CSS_HIDE, true); 
		},
		
		loadData: function() {
			var languageParameter = this.workingCopy.currentLanguage ? "?lang=" + this.workingCopy.currentLanguage : ""; //$NON-NLS-1$ //$NON-NLS-2$
			ProcessAuthoringClient.getProcessDescription({
				lastModified: this.workingCopy.lastModified,
				resourceURL: this.resourceURL + languageParameter,
				load: dojo.hitch(this, function(data, ioArgs) {
					this.processDescriptionETag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
					this.populateData(data);
					this.resizeEditor();
				}),
				error: dojo.hitch(this, function(error, ioArgs) {
					//TODO report error bug 104182
					if (error.responseText && error.status == ProcessAuthoringConstants.SC_FORBIDDEN) {
						error.headerMessage = this.messages.ProcessDescriptionError_3;
						this._handleResponseError(error, ioArgs, true);
					} else {
						this.displayErrorMessage(error);
					}
				})
			});
		},
		
		populateData: function(data) {
			var pd = new PracticeElement({
				xml: data
			});
			this.processDescriptionXML = data;
			this.isShared = pd.isSharedByOwner();
			this.isPLMShared = pd.isSharedByElement();
			this.processDescriptionLanguage = pd.language;
			this.processDescriptionName = pd.title;
			this.processDescriptionOwner = pd.getOwnerURL();
			this.processDescriptionOwnerName = pd.getOwnerName();
			this.processDescriptionId = this.resourceURL.substring(this.resourceURL.lastIndexOf('/') + 1); //$NON-NLS-1$
			this.processDescription = pd.description;
			this.processDescriptionArchived = pd.archived;
			
			this.workingCopy.currentLanguage = this.processDescriptionLanguage;
			this.workingCopy.sharedSupport = this.sharedSupport;
			var languages = pd.languages;
			this.workingCopy.addProcessDescription({
				resourceURL: this.resourceURL,
				title: this.processDescriptionName,
				description: this.processDescription,
				owner: this.processDescriptionOwner,
				ETag: this.processDescriptionETag,
				isPLMShared: this.isPLMShared,
				languages: languages,
				practiceList: [],
				archived: this.processDescriptionArchived
			});
			
			if (this.isNew) {
				this.detailEditor.toggleViewEditMode(ProcessAuthoringConstants.EditorMode.EDIT);
			} else {
				this._toggleHiddenButtons(false);
				if (!this.detailEditor) {
					this._createDetailEditor(this.isShared);
					this.detailWrapper.appendChild(this.detailEditor.domNode);
				}
				if (!this.switchLanguageToolbar) {
					this._switchLanguageButton = new jazz.ui.toolbar.Button({
						imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/language-button.gif"), //$NON-NLS-1$ //$NON-NLS-2$
						title: this.messages.ProcessDescriptionEditor_16,
						onClick: dojo.hitch(this, this.switchLanguage)
					});
					
					this.switchLanguageToolbar = new jazz.ui.Toolbar();
					this.switchLanguageToolbar.addChild(this._switchLanguageButton);
					this.detailEditor.switchLanguageButtonContainer.appendChild(this.switchLanguageToolbar.domNode);
					dojo.addClass(this.detailEditor.switchLanguageButtonContainer, "float-left"); //$NON-NLS-1$
				}
				
				this.detailEditor.displayLanguage(true);
				this.detailEditor.setLanguage(this.getFullLanguage(this.processDescriptionLanguage));
				this.detailEditor.set("ownerReadOnly", true); //$NON-NLS-1$
				if (this.viewMode) {
					this.detailEditor.toggleViewEditMode(ProcessAuthoringConstants.EditorMode.PREVIEW);
				} else {
					this.detailEditor.toggleViewEditMode(ProcessAuthoringConstants.EditorMode.EDIT);
				}
				this.detailEditor.defaultField.checked = this._isDefaultLanguage();
			}
			
			this.resetAllFields();
			this.initializeNavigator();
		},
		
		_isDefaultLanguage: function() {
			return this.workingCopy.currentLanguage == this.workingCopy.processDescription.defaultLanguage;
		},
		
		_setDefaultLanguage: function(evt) {
			this.workingCopy.setProcessDescriptionDefaultLanguage(evt.target.checked ? this.workingCopy.currentLanguage : null);
		},
		
		_createDetailEditor: function(isShared) {
			var args = {
				descriptionContent: this.processDescription,
				ownerURL: this.processDescriptionOwner,
				languageText: this.processDescriptionLanguage,
				hideLanguage: this.isNew,
				isNew: this.isNew,
				container: this,
				viewOnly: this.viewOnly,
				viewMode: this.viewMode
			}
			if ( isShared && UIHelper.isPracticeLibraryApp() ) {
				args.sharingCheckType = this.isPLMShared? ProcessAuthoringConstants.DETAILEDITOR_CHECKBOXTYPE_CHECKED:ProcessAuthoringConstants.DETAILEDITOR_CHECKBOXTYPE_UNCHECKED;				
			}
			if ( !this.isNew ) {
				args.onSize = dojo.hitch(this, this.resizeEditor);
			}
			
			this.detailEditor = new ProcessDescriptionDetailEditor(args);
            if (!this.viewOnly) {
            	var inputFields = [this.detailEditor.description, this.detailEditor.owner];
            	for (var i = 0; i < inputFields.length; i++) {
            		this.connect(inputFields[i], "onkeyup", "_handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
            		this.connect(inputFields[i], "onchange", "_handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
            	}
            	this.connect(this.detailEditor.sharingField, "onclick", "_handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
            	this.connect(this.detailEditor.defaultField, "onclick", "_handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
            }
		},
		
		_onPLMSharingChange: function() {
			this.isPLMShared = this.detailEditor.sharingField.checked;
		},		
		 
		resetAllFields: function() {
			this.name.value = this.processDescriptionName ? this.processDescriptionName : this.messages.ProcessDescriptionEditor_7;
			this.name.style.display = "none"; //$NON-NLS-1$
			this.previewName.innerHTML = UIHelper.escapeXML(this.name.value);
			this.previewName.style.display = ""; //$NON-NLS-1$
			this.detailEditor.setDescription(this.processDescription);
			if (!this.isShared) {
				var url = this.processDescriptionOwner ? this.processDescriptionOwner : this.DEFAULT_PROCESSDESCRIPTION_OWNERURL;
				var name = this.processDescriptionOwnerName ? this.processDescriptionOwnerName : url;
			}
		},
		
		_changeToEditMode: function() {
			//setup practice panel
			dojo.toggleClass(this.contentWrapper, ProcessAuthoringConstants.CSS_HIDE, false);
			this.isNew = false;
			this.clearChangesPending();
			this.refresh();
		},
		
		initializeNavigator: function() {
			if (!this.workingCopy.currentItem) {
				if (this.workingCopy.currentPracticeResource) {
					this.workingCopy.currentItem = UIHelper.getResourceId(this.workingCopy.currentPracticeResource);
				} else if (this.practiceElementUrl) {
					this.workingCopy.currentItem = UIHelper.getResourceId(this.practiceElementUrl);
				} else if (this.practiceUrl) {
					this.workingCopy.currentItem = UIHelper.getResourceId(this.practiceUrl);
				}
			}
			this.fetchProcessDescriptionTree(this.resourceURL);
			var practiceInfoList = UIHelper.getAllPracticesFromProcessDescription(this.processDescriptionXML, true);
			// clear XML data from memory since it will no longer be used
			this.processDescriptionXML = null;
			
			//load practice tree
			this.practiceTreePane = new PracticeTreePane({
				onAddPractice: dojo.hitch(this, this.onAddPractice),
				viewOnly: this.viewOnly,
				isAssociated: this.viewOnly
			});
			this.practicePane.set('content', this.practiceTreePane); //$NON-NLS-1$
			
			// populate all the practices using the name and url in presentation of process description
			var locatingPractice, currentPractice;
			for (var i = 0; i < practiceInfoList.length; i++) {
				var practiceInfo = practiceInfoList[i];
				if (this.workingCopy.currentPracticeResource && this.workingCopy.currentPracticeResource === practiceInfo.url) {
					currentPractice = practiceInfo;
				} else if (this.practiceUrl && this.practiceUrl === practiceInfo.url) {
					locatingPractice = practiceInfo;
				}
				if (practiceInfo.shared === "true") { //$NON-NLS-1$
					this.workingCopy.addPracticeToPracticeList({
						url: practiceInfo.url,
						name: practiceInfo.title,
						shared: "true", //$NON-NLS-1$
						isArchived: practiceInfo.isArchived
					}, false);
					if (this.sharedSupport) {
						this.buildPlainPracticeTree(practiceInfo, this.practiceTreePane, true);
					}
				} else {
					this.workingCopy.addPracticeToPracticeList({
						url: practiceInfo.url,
						name: practiceInfo.title,
						shared: "false", //$NON-NLS-1$
						isArchived: practiceInfo.isArchived
					}, false);
					this.buildPlainPracticeTree(practiceInfo, this.practiceTreePane, false, this.isPracticePaneShowArchivedButtonPressed());
				}
			}
			
			// calculate the first practice that need to be loaded
			var firstLoadPractice;
			if (this.practiceElementUrl || this.practiceUrl || this.workingCopy.currentPracticeResource) {
				if (currentPractice) {
					firstLoadPractice = currentPractice;
				} else if (locatingPractice) {
					firstLoadPractice = locatingPractice;
				}
			}
			
			// calculate bulk fetching practice URLs 
			var practiceURLs = new Array();
			for (var i = 0; i < practiceInfoList.length; i++) {
				var practiceInfo = practiceInfoList[i];
				// if there is no firstLoadPractice, then check if the license allow fetching current practice.
				// if there is a firstLoadPractice, and the current practice is not the firstLoadPractice which is already loaded, 
				// then check if the license allow fetching current practices.
				if ((!firstLoadPractice || (firstLoadPractice && (practiceInfo.url !== firstLoadPractice.url))) && (this.sharedSupport || (practiceInfo.shared === "false"))) { //$NON-NLS-1$
					practiceURLs.push(practiceInfo.url);
				}
			}
			
			// nothing need to be loaded
		    if (!firstLoadPractice && practiceURLs.length === 0) {
				this.clearLoadingMessage();
				// only check newly created success message for shared process description
				if (this.isShared) {
					this.checkForSuccessMsg();
				}
			} else {
				// fetch the first practice
				if (firstLoadPractice) {
					this.fetchPracticeTree(firstLoadPractice.url, this.practiceTreePane, (firstLoadPractice.shared === "true"), dojo.hitch(this, function() { //$NON-NLS-1$
						var currentNode = this.workingCopy.getNodeById(this.workingCopy.currentItem);
						var showArchived = false;
						if (currentNode.node) {
							showArchived = currentNode.node.isArchived;
						} else if (currentNode.practice) {
							showArchived = currentNode.practice.isArchived;
						}
						if (showArchived) {
							// if the first load element is archived, we should set the Pressed status
							// of the Show Archived button to true and then update the tree.
							this._showArchivedButton.set("pressed", true); //$NON-NLS-1$
							this._updateTreePaneWithShowArchivedStatus(this.practiceTreePane, true);
						}
						this.openCurrentItem(this.practiceTreePane, (firstLoadPractice.shared === "true")); //$NON-NLS-1$
						// if there is no other practices need to be loaded, then set the practices are loaded done.
						if (practiceURLs.length === 0) {
							this.publishLoadedDone();
						}
					}));
				}
				
				// bulk fetching practices
				if (practiceURLs.length > 0) {
					var successCallback = dojo.hitch(this, function(responses, ioArgs) {
						for (var i = 0; i < practiceInfoList.length; i++) {
							var practiceInfo = practiceInfoList[i];
							var idx = dojo.indexOf(practiceURLs, practiceInfo.url);
							if (practiceInfo.shared === "true") { //$NON-NLS-1$
								if (this.sharedSupport) {
									if (idx > -1 && this.checkResponse(responses[idx])) {
										this.buildPracticeTree(responses[idx], this.practiceTreePane, true);
									}
								} else {
									// try to fetch shared practice to get the license related message from server
									// see bug 161886
									if (!this.hasTryToLoadShared) {
										this.loadPracticeTree(practiceInfo.url, this.practiceTreePane, true);
										this.hasTryToLoadShared = true;
									}
								}
							} else {
								if (idx > -1 && this.checkResponse(responses[idx])) {
									this.buildPracticeTree(responses[idx], this.practiceTreePane, false);
								}
							}
							
							// if this practice is the last one, publish the subject "practices_loaded_done" or attempt to locate it in the tree  
							if (i == practiceInfoList.length - 1) {
								this.publishLoadedDone();
							}
						}
							
						this._updateTreePaneWithShowArchivedStatus(this.practiceTreePane, this.isPracticePaneShowArchivedButtonPressed());
					});
					var errorCallback = dojo.hitch(this, function(error, ioArgs) {
						this.displayErrorMessage(error);
					});
					var practiceURLsWithLang = ProcessAuthoringClient.addLanguageParameterInURLs(practiceURLs, this.workingCopy.currentLanguage);
					ProcessAuthoringClient.fetchResources(practiceURLsWithLang, null, successCallback, errorCallback);
				}
			}
			
			// add the action buttons in practices tree pane
			if (!this.viewOnly && this.isFirstLoad) {
				var nodeList = dojo.query('.dijitAccordionTitle', this.domNode); //$NON-NLS-1$
				this.viewToolBar = new jazz.ui.Toolbar({});
				dojo.addClass(this.viewToolBar.domNode, "float-right"); //$NON-NLS-1$
				if (this.sharedSupport) {
					this.viewToolBar_AddSharedPracticeButton = new jazz.ui.toolbar.Button({
						imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/add-shared-practice_co.gif"), //$NON-NLS-1$ //$NON-NLS-2$
						title: this.messages.PracticeTreePane_4, 
						onClick: dojo.hitch(this, this._onAddSharedPracticeButtonClick)
					});
					this.viewToolBar.addChild(this.viewToolBar_AddSharedPracticeButton);
				}
				
				this.viewToolBar_AddPrivatePracticeButton = new jazz.ui.toolbar.Button({
					imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/create-practice_co.gif"), //$NON-NLS-1$ //$NON-NLS-2$
					title: this.messages.PracticeTreePane_0, 
					onClick: dojo.hitch(this, this._onAddPrivatePracticeButtonClick)
				});
				this.viewToolBar.addChild(this.viewToolBar_AddPrivatePracticeButton);
				
				this.viewToolBar_ImportPracticeButton = new jazz.ui.toolbar.Button({
					imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/import-practice_co.gif"), //$NON-NLS-1$ //$NON-NLS-2$
					title: this.messages.PracticeTreePane_3, 
					onClick: dojo.hitch(this, this._onImportPracticesButtonClick)
				});
				this.viewToolBar.addChild(this.viewToolBar_ImportPracticeButton);

				// add Show Archived button in both view and edit mode
				this._showArchivedButton = new jazz.ui.toolbar.TwoStateButton({
					imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/show_archived_obj.gif"), //$NON-NLS-1$ //$NON-NLS-2$
					title: this.messages.PracticeTreePane_5,
					onClick: dojo.hitch(this, this._onShowArchivedButtonClick)
				});
				this.viewToolBar.addChild(this._showArchivedButton);
				
				dojo.place(this.viewToolBar.domNode, nodeList[this.outlinePane ? 1 : 0], "first"); //$NON-NLS-1$

				this.isFirstLoad = false;
				if (this.viewMode) {
					this.viewToolBar_AddPrivatePracticeButton.set("visible", false); //$NON-NLS-1$
					this.viewToolBar_ImportPracticeButton.set("visible", false); //$NON-NLS-1$
					if (this.sharedSupport) {
						this.viewToolBar_AddSharedPracticeButton.set("visible", false); //$NON-NLS-1$
					}
				}
			}
		},
		
		_onImportPracticesButtonClick: function() {
            this.leftNavigator.selectChild(this.practicePane);
            if ((!this.changesPending()) || (this.changesPending() && confirm(this.messages.ProcessDescriptionEditor_21))) {
				if (this.changesPending()) {
					// refresh to discard unsaved changes
					this.refresh();
				}
            	var importDialog = new ImportDialog({
            		processDescriptionUrl: this.resourceURL
            	});
            	this.connect(importDialog, "onSuccess", "_handleImportSuccess");//$NON-NLS-1$ //$NON-NLS-2$
            	this.connect(importDialog.dialog, "onClose", "_handleImportFinish");//$NON-NLS-1$ //$NON-NLS-2$
            }
		},
		
		_onShowArchivedButtonClick: function(event) {
			dojo.stopEvent(event);

			// refresh tree pane
			this._updateTreePaneWithShowArchivedStatus(this.practiceTreePane, this.isPracticePaneShowArchivedButtonPressed());
		},
		
		_onOutlinePaneShowArchivedButtonClick: function(event) {
			dojo.stopEvent(event);
			
			// refresh tree pane
			this._updateTreePaneWithShowArchivedStatus(this.processDescriptionTreePane, this.isOutlinePaneShowArchivedButtonPressed());
		},

		_updateTreePaneWithShowArchivedStatus: function(treePane, isShowArchivedButtonPressed) {
			if (treePane && treePane.trees && treePane.trees.length > 0) {
				for (var i = 0; i < treePane.trees.length; i++) {
					var showArchived = isShowArchivedButtonPressed;
					var practiceTree = treePane.trees[i];
					
					// update showArchived in the model
					practiceTree.model.showArchived = showArchived;
		
					// show or hide this whole practice tree
					if (!showArchived && practiceTree.model.root.isArchived) {
						// hide this practice tree
						dojo.addClass(practiceTree.domNode, ProcessAuthoringConstants.CSS_HIDE);
					} else {
						// show this practice tree
						dojo.removeClass(practiceTree.domNode, ProcessAuthoringConstants.CSS_HIDE);
						practiceTree.update();
					}
				}
				
				// handle focus change
				if (isShowArchivedButtonPressed) {
					// open the last focus item if this item is an archived item
					if (this.lastFocusedArchivedItem) {
						var node = this.workingCopy.getNodeById(this.lastFocusedArchivedItem);
						if (node) {
							if ((node.node && node.node.isArchived) || (node.practice && node.practice.isArchived)) {
								this.workingCopy.currentItem = this.lastFocusedArchivedItem;
								this.initializedContentEditor = false; // make sure this item could be re-open
								this.openCurrentItem(this.practiceTreePane, false);
							}
						}
					}
				} else {
					// clear the focus if this item is archived
					if (this.workingCopy.currentItem) {
						var node = this.workingCopy.getNodeById(this.workingCopy.currentItem);
						if (node) {
							if ((node.node && node.node.isArchived) || (node.practice && node.practice.isArchived)) {
								this.rightContent.set('content', ''); //$NON-NLS-1$ //$NON-NLS-2$
								this.lastFocusedArchivedItem = this.workingCopy.currentItem;
								this.workingCopy.currentItem = null;
								this.workingCopy.currentPracticeResource = null;
								return;
							}
						}
					}
					this.lastFocusedArchivedItem = null;
				}
			}
		},
		
		isShowArchivedButtonPressed: function () {
			if (this.leftNavigator.selectedChildWidget) {
				if (this.leftNavigator.selectedChildWidget === this.practicePane) {
					return this.isPracticePaneShowArchivedButtonPressed();
				} else if (this.leftNavigator.selectedChildWidget === this.outlinePane) {
					return this.isOutlinePaneShowArchivedButtonPressed();
				}
			}
			return false;
		},
		
		isPracticePaneShowArchivedButtonPressed: function () {
			if (this._showArchivedButton) {
				return this._showArchivedButton.pressed;
			}
			return false;
		},
		
		isOutlinePaneShowArchivedButtonPressed: function () {
			if (this.outlinePaneToolbar && this._showArchivedButtonOnOutlinePane) {
				return this._showArchivedButtonOnOutlinePane.pressed;
			}
			return false;
		},

		_handleImportSuccess: function(args) {
			if (typeof(args.resourceCount) === 'undefined') { //$NON-NLS-1$
				return;
			}
			// update working copy to add newly imported practices' reference in process description
			var resourceUrlPrefix = args.resourceUrlPrefix;
			var resourceIdArray = args.resourceIds.split(":"); //$NON-NLS-1$
			for (var i = 0; i < args.resourceCount; i++) {
				this.workingCopy.addPracticeToPracticeList({
					url: resourceUrlPrefix + resourceIdArray[i],
					name: "", //$NON-NLS-1$
					shared: "false" //$NON-NLS-1$
				}, true);
			}
			// save process description for practices' reference updating
			this._practiceReferenceUpdateDoneHandle = dojo.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_UPDATEDONE, this, this._handlePracticeReferenceUpdateResult);
			this.workingCopy.executeUpdate();
			this._isImportSucceeded = true;
		},
		
		_handlePracticeReferenceUpdateResult: function(results) {
			for (var i = 0; i < results.length; i++) {
				var result = results[i];
				if (!result.success) {
					// display the first error.
					this.displayErrorMessage(result);
					break;
				}
			}
			
			if (this._practiceReferenceUpdateDoneHandle) {
				dojo.unsubscribe(this._practiceReferenceUpdateDoneHandle);
				this._practiceReferenceUpdateDoneHandle = null;
			}
		},
		
		_handleImportFinish: function() {
			if (this._isImportSucceeded) {
				this.refresh();
				this._isImportSucceeded = false;
			}
		},
		
		/**
         * When get ProcessAuthoringConstants.PUBLISHTYPE_PRACTICES_LOAD_DONE message,
         * try to publish ProcessAuthoringConstants.PUBLISHTYPE_LINK_ACTION_READY to invoke linkAction()
         */
		practicesLoadDone: function() {
			// If all the practices are loaded, then call linkAction() to locate url in practice tree  
			if (this.allPracticesLoaded) {
				if (this.linkActionHandle && this.locateUrl) {
					dojo.publish(ProcessAuthoringConstants.PUBLISHTYPE_LINK_ACTION_READY, [this.locateUrl]);
					this.locateUrl = null;
				}
			}
			this.inherited(arguments);
		},
		
		loadPracticeTree: function(url, treePane, shared) {
			this.fetchPracticeTree(url, treePane, shared, dojo.hitch(this, function() {
				this.openCurrentItem(treePane, shared);
			}));
		},
		
	    publishLoadedDone: function() {
			if (this.practicesLoadDoneHandle) {
				this.allPracticesLoaded = true;
				dojo.publish(ProcessAuthoringConstants.PUBLISHTYPE_PRACTICES_LOAD_DONE);
			}
		},
		
		togglePrimaryField: function(mode) {
			if (mode === ProcessAuthoringConstants.EditorMode.PREVIEW) {
				this.name.style.display = ProcessAuthoringConstants.NONE;
				dojo.empty(this.previewName);
				this.previewName.appendChild(document.createTextNode(this.name.value || this.messages.ProcessDescriptionEditor_7));
				this.previewName.style.display = ProcessAuthoringConstants.EMPTY;
			} else if (mode === ProcessAuthoringConstants.EditorMode.EDIT) {
				this.previewName.style.display = ProcessAuthoringConstants.NONE;
				this.name.style.display = ProcessAuthoringConstants.EMPTY;
				this.name.focus();
				this.name.select();
			}
		},
		
		loadError: function() {
			//TODO error handling
		},
		
		refresh: function() {
			this._clearMessage();
			this.displayWaitingMessage(this.messages.ProcessDescriptionEditor_23);					
			this.inherited(arguments);
			this.workingCopy.clean();
			this.practicePane.set('content', ""); //$NON-NLS-1$ //$NON-NLS-2$
			this.isRefreshCalled = true; 
			this.allPracticesLoaded = false;
			this.lastFocusedArchivedItem = null;
			this.loadData();
		},
		
		onRefresh: function(e) {
            if (e) {
            	dojo.stopEvent(e);
            }
            if (this.isNew) {
				if (this.changesPending() && confirm(this.messages.ProcessDescriptionEditor_8)) {
					this.clearChangesPending();
					this.processDescriptionName = this.messages.ProcessDescriptionEditor_7;
					this.processDescription = ""; //$NON-NLS-1$
					dojo.empty(this.detailWrapper);
					this._showUIForCreation();
				}
			} else {
				if (!this.changesPending() || (this.changesPending() && confirm(this.messages.ProcessDescriptionEditor_8))) {
					this.refresh();
				}
			}
		},
		
		getResult: function(results) {
			if (this.inherited(arguments)) {
				this.displaySuccessMessage(this.messages.ProcessDescriptionEditor_2);
				return true;
			}
			return false;
		},
		
		doSave: function() {
			this.autoCommitEditor();
			
			var msg = this.validateFields();
			if (msg) {
				this.displayErrorMessage(msg);
				return;
			}
			
			if (this.isNew === true) {
				jazz.ui.underlay.show();
				//url is like this: https://localhost:9443/jazz/process/project-areas/_EsMFQg_MEd-YF9W184A5vA
				var successCallback = dojo.hitch(this, function(location, ETag) {
					jazz.ui.underlay.hide();
					this.resourceURL = location;
					this.processDescriptionETag = ETag;
					this._changeToEditMode();
					// saveResultCallback is specific to ProcessAreaDescriptionEditor
					if (this.saveResultCallback) {
						this.saveResultCallback();
					} else {
						// set the save success message in cookie and change the URL of process description editor in PL  
						dojo.cookie(this.msgCookieName, this.messages.ProcessDescriptionEditor_0);
				        this._unregisterHandlers();
				        document.location.href = PROCESS_DESCRIPTION_EDIT_ACTION_PREFIX + this.resourceURL; 
					}
				});
				var errorCallback = dojo.hitch(this, function(error) {
					jazz.ui.underlay.hide();
					var errObj = {};
					errObj.headerMessage = error.headerMessage ? error.headerMessage : this.messages.ProcessDescriptionError_0;
					if (error.responseText) {
						errObj.message = error.responseText;
					}
					if (this.saveResultCallback) {
						this.saveResultCallback(errObj);
					} else {
						this.displayErrorMessage(errObj);
					}
				});
				if (this.isShared) {
					ProcessAuthoringClient.createSharedProcessDescription({
						title: UIHelper.escapeXML(this.processDescriptionName),
						isPublished: this.isPLMShared,
						description: this.processDescription,
						successCallback: successCallback,
						errorCallback: errorCallback
					});
				} else {
					ProcessAuthoringClient.createProcessDescriptionForProcessArea({
						title: UIHelper.escapeXML(this.processDescriptionName),
						description: this.processDescription,
						language: this.workingCopy.currentLanguage,
						ownerUrl: this._getOwner(),
						successCallback: successCallback,
						errorCallback: errorCallback
					});
				}
			} else {
				this.inherited(arguments);
			}
		},
		
		validateFields: function() {
			if (!this._getProcessDescriptionName() || dojo.trim(this._getProcessDescriptionName()).length === 0) {
				return this.messages.ProcessDescriptionEditor_9;
			}
			if (!this.isShared) {
				if (!this.processDescriptionOwner || dojo.trim(this.processDescriptionOwner).length === 0) {
					return this.messages.ProcessDescriptionEditor_10;
				}
			}
			if (this.workingCopy.processDescription && !this.workingCopy.processDescription.defaultLanguage) {
				return this.messages.ProcessDescriptionEditor_27;
			}
		},
		
		_handleChange: function(e) {
			//don't stop the event propagation for checkbox, otherwise, the checkbox UI will not change
			if ( e.currentTarget.type !== "checkbox") { //$NON-NLS-1$ 
				dojo.stopEvent(e);
			}
			var hasUpdate = false;
			switch (e.currentTarget.name) {
				case this.TITLE_LABEL:
					hasUpdate = (this.processDescriptionName !== e.target.value);
					if (hasUpdate) {
						this._getProcessDescriptionName(hasUpdate);
					}
					break;
				case this.OWNER_LABEL:
					if (this.detailEditor.get("ownerReadOnly")) { //$NON-NLS-1$
						return;
					}
					hasUpdate = (this.processDescriptionOwner !== e.target.value);
					if (hasUpdate) {
						this._getOwner(hasUpdate);
					}
					break;
				case this.PLMSHARED_TARGET:
					hasUpdate = true;
					this._onPLMSharingChange();
					break;
				case "default": //$NON-NLS-1$
					hasUpdate = true;
					this._setDefaultLanguage(e);
					break;
				case "description": //$NON-NLS-1$
					hasUpdate = (this.processDescription !== e.target.value);
					if (hasUpdate) {
						this._getDescription(hasUpdate);
					}
					break;
				default:
					break;
			}
			
			if (hasUpdate) {
				if (!this.isNew) {
					this._updateWorkingCopy();
				}
				this.setChangesPending();
			}
		},
		
		_onAddSharedPracticeButtonClick: function(evt) {
			dojo.stopEvent(evt);
			this.onAddSharedPractice(this.practiceTreePane);
		},
		
		_onAddPrivatePracticeButtonClick: function(evt) {
			dojo.stopEvent(evt);
            this.leftNavigator.selectChild(this.practicePane);
			this.onAddPractice(this.practiceTreePane);
		},
		
		onAddSharedPractice: function(treePane) {
			//callbackFunction
			var sharedPracticePicker = new SharedPracticeSelectionDialog({
				selectedResources: this.workingCopy.getPracticeList()
			});
			this.connect(sharedPracticePicker, "onAdd", "addSharedPractice"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		addSharedPractice: function(selectedPractices) {
			var practiceURLs = new Array();
			for (var i = 0; i < selectedPractices.length; i++) {
				var practice = selectedPractices[i];
				practiceURLs.push(practice.url);
				
			}
			var successCallback = dojo.hitch(this, function(responses, ioArgs) {
				dojo.forEach(selectedPractices, function(practice, idx) {
					if (!this.workingCopy.practiceIndexMap[practice.url]) {
						this.workingCopy.addPracticeToPracticeList({
							name: practice.name,
							url: practice.url,
							shared: "true" //$NON-NLS-1$
						}, true);
						if (this.checkResponse(responses[idx])) {
							this.buildPracticeTree(responses[idx], this.practiceTreePane, true);
							this.setChangesPending();
						}
					}
				}, this);
				dojo.publish(ProcessAuthoringConstants.PUBLISHTYPE_PRACTICES_LOAD_DONE);
			});
			var errorCallback = dojo.hitch(this, function(error, ioArgs) {
				this.displayErrorMessage(error);
			});
			if (practiceURLs.length > 0) {
				this.displayWaitingMessage(this.messages.ProcessDescriptionEditor_23);
				ProcessAuthoringClient.fetchResources(practiceURLs, null, successCallback, errorCallback);
			}
		},
		
		checkResponse: function(response) {
			if (response.status == 200) {
				return true;
			} else {
				var error = new Error();
				error.status = response.status;
				error.message = response.body;
				if (response.body && response.status == ProcessAuthoringConstants.SC_FORBIDDEN && response.warning) {
					error.headerMessage = this.messages.ProcessDescriptionEditor_1;
					this.displayWarningMessage(error, false);
				} else {
					this.displayErrorMessage(error);
				}
				return false;
			}
		},
		
		onRemoveSharedPractice: function(item, practiceResource, treeContainer) {
			if (confirm(dojo.string.substitute(this.messages.ProcessDescriptionEditor_11, [item.label]))) {
				treeContainer.removePracticeTree(practiceResource);
				this.workingCopy.removePracticeFromPracticeList(practiceResource);
				this.setChangesPending();
				if (this.workingCopy.isParent(practiceResource, practiceResource, this.workingCopy.currentItem)) {
					this.rightContent.set('content', ''); //$NON-NLS-1$ //$NON-NLS-2$
				}
			}
		},
		
		handlePromoteError: function(err, ioArgs) {
			var licenseWarning = null;
			if (ioArgs) {
				licenseWarning = UIHelper.getLicenseWarning(ioArgs);
			}
			var result = {
				success: false,
				headerMessage: licenseWarning ? licenseWarning : this.messages.ProcessDescriptionError_1,
				type: "promotePrivatePractice", //$NON-NLS-1$
				message: err.responseText ? err.responseText : err.message, 
				errorData: err
			}
			this.getResult([result]);
		},
		
		onPromotePractice: function(item, practiceResource, treeContainer) {
            
            if ( confirm(dojo.string.substitute(this.messages.ProcessDescriptionEditor_24, [item.label]))) {
                if (!this.changesPending() || (this.changesPending() && confirm(this.messages.AbstractPracticesEditor_7))) {
					if (this.changesPending()) {
					    // refresh to discard unsaved changes
						this.refresh();
					}
					
					var practice = this.workingCopy.getPracticeInPracticeList(practiceResource);
					if (practice) {
						practice.shared = "true"; //$NON-NLS-1$
					}
					
                	//update process description and practice
                	this._doPromote(practiceResource);
                	treeContainer.removePracticeTree(practiceResource);
                }
            }
			
		},		
		
	    /**
	     * Promote a private practice as a shared one.
	     * 
	     * @param {String} practiceResource URL of the practice to be promoted.
	     */
		_doPromote: function(practiceResource) {
			ProcessAuthoringClient.getPractice({
				lastModified: this.workingCopy.lastModified, //$NON-NLS-1$
				url: practiceResource,
				load: dojo.hitch(this, function(data, ioArgs) { //$NON-NLS-1$
					var ETag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
					var practice = new PracticeElement({
						xml: data
					});
					
					ProcessAuthoringClient.updatePractice({
						ETag: ETag,
						putData: practice.getPromotedElementXML(),
						practiceId: practice.getElementID(),
						load: dojo.hitch(this, function(data, ioArgs) {
							this.workingCopy.lastModified = ioArgs.xhr.getResponseHeader("Last-Modified"); //$NON-NLS-1$
							this.refresh();
							this.displaySuccessMessage(this.messages.ProcessDescriptionEditor_25);
						}),
						error: dojo.hitch(this, function(err, ioArgs) {
							this.handlePromoteError(err, ioArgs);
						})
					});
				}),
				error: dojo.hitch(this, function(err, ioArgs) {
					this.handlePromoteError(err, ioArgs);
				})
			});
		},
		
		_updateWorkingCopy: function() {
			this.workingCopy.updateProcessDescription({
				resourceURL: this.resourceURL,
				isPLMShared: this.isPLMShared,
				title: this.processDescriptionName,
				description: this.processDescription,
				owner: this.processDescriptionOwner
			});
		},
		
		_getProcessDescriptionName: function(hasUpdate) {
			this.processDescriptionName = this.name.value;
			return this.processDescriptionName;
		},
		
		_getDescription: function() {
			this.processDescription = this.detailEditor.description.value;
			return this.processDescription;
		},
		
		_getOwner: function() {
			//comment it, currently, owner can't be modified, and the value is ownerName, that's not what want.
			//			this.processDescriptionOwner = this.detailEditor.owner.value;
			return this.processDescriptionOwner;
		},
		
		getModelETag: function() {
			return this.workingCopy.processDescription.model.ETag;
		},
		
		setETag: function(ETag) {
			this.processDescriptionETag = ETag;
			this.workingCopy.processDescription.model.ETag = UIHelper.extractETag(ETag).modelETag;
		},
		
		getResourceID: function() {
			return this.resourceURL.substring(this.resourceURL.lastIndexOf("/") + 1, this.resourceURL.length); //$NON-NLS-1$
		},
		
		uninitialize: function() {
			if (this._showArchivedButtonOnOutlinePane) {
				this._showArchivedButtonOnOutlinePane.destroyRecursive();
			}
			
			if (this._showArchivedButton) {
				this._showArchivedButton.destroyRecursive();
			}
			
			if (this.viewToolBar_AddPrivatePracticeButton) {
				this.viewToolBar_AddPrivatePracticeButton.destroyRecursive();
			}
			
			if (this.viewToolBar_ImportPracticeButton) {
				this.viewToolBar_ImportPracticeButton.destroyRecursive();
			}
			
			if (this.viewToolBar_AddSharedPracticeButton) {
				this.viewToolBar_AddSharedPracticeButton.destroyRecursive();
			}
			
			if (this.detailEditor) {
				this.detailEditor.destroyRecursive();
			}
			
			if (this.linkActionHandle) {
				dojo.unsubscribe(this.linkActionHandle);
				this.linkActionHandle = null;
			}
	
			if (this._switchLanguageButton) {
				this._switchLanguageButton.destroyRecursive();
			}
					
			if (this.switchLanguageToolbar) {
				this.switchLanguageToolbar.destroyRecursive();
			}

			if (this.viewToolBar) {
				this.viewToolBar.destroyRecursive();
			}
			
			if (this.outlinePaneToolbar) {
				this.outlinePaneToolbar.destroyRecursive();
			}

			this.inherited(arguments);
		},
		
		fetchPractices: function(practiceNodes, urlToXmlMap, onFinish) {
			var node = practiceNodes.shift();
			if(node) {
				var url = UIHelper.getNodeResource(node);
				if(url) {
					ProcessAuthoringClient.getResource({
						lastModified: this.workingCopy.lastModified,
						url: url + "?lang=" + this.workingCopy.currentLanguage + "&view=structure", //$NON-NLS-1$ //$NON-NLS-2$
						load: dojo.hitch(this, function(data, ioArgs) {
							urlToXmlMap[url] = data;
							this.fetchPractices(practiceNodes, urlToXmlMap, onFinish);
						})
					});
				} else {
					this.fetchPractices(practiceNodes, urlToXmlMap, onFinish);
				}
			} else {
				onFinish();
			}
		},
		
		fetchProcessDescriptionTree: function(url) {
			ProcessAuthoringClient.getResource({
				lastModified: this.workingCopy.lastModified,
				url: url + "?lang=" + this.workingCopy.currentLanguage + "&view=structure", //$NON-NLS-1$ //$NON-NLS-2$
				load: dojo.hitch(this, function(data, ioArgs) {
					var presentations = dojo.query(ProcessAuthoringConstants.XMLELEMENT_PRESENTATION, data);
					if (presentations && presentations.length > 0) {
						var eTag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
						// find URLs of all practices
						var practiceNodes = dojo.query(ProcessAuthoringConstants.XMLELEMENT_PRACTICE, data);
						var urlToXmlMap = {};
						this.fetchPractices(practiceNodes, urlToXmlMap, dojo.hitch(this, function() {
							// Outline pane
							// show outline pane only if process description has a structure presentation
							//
                            
                            if (!this.outlinePane) {
                            	this.outlinePane = new dijit.layout.ContentPane({
                            		title: this.messages.ProcessDescriptionEditor_18,
                            		selected: "true", //$NON-NLS-1$
                            		disabled: false
                            	}, document.createElement("DIV")); //$NON-NLS-1$
                            	this.leftNavigator.addChild(this.outlinePane, 0);
                            	if (this.viewMode) {
                            		this.leftNavigator.selectChild(this.outlinePane);
                            	} else {
                            		this.leftNavigator.selectChild(this.practicePane);
                            		this.outlinePane.disabled = true;
                            	}
								
								// add Show Archived button in outline pane
								this.outlinePaneToolbar = new jazz.ui.Toolbar({});
								dojo.addClass(this.outlinePaneToolbar.domNode, "float-right"); //$NON-NLS-1$
								this._showArchivedButtonOnOutlinePane = new jazz.ui.toolbar.TwoStateButton({
									imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/show_archived_obj.gif"), //$NON-NLS-1$ //$NON-NLS-2$
									title: this.messages.PracticeTreePane_5,
									onClick: dojo.hitch(this, this._onOutlinePaneShowArchivedButtonClick)
								});
								this.outlinePaneToolbar.addChild(this._showArchivedButtonOnOutlinePane);
								var nodeList = dojo.query('.dijitAccordionTitle', this.leftNavigator.domNode); //$NON-NLS-1$
								dojo.place(this.outlinePaneToolbar.domNode, nodeList[0], "first"); //$NON-NLS-1$
                            }
							// load process description outline
							this.processDescriptionTreePane = new PracticeTreePane({
								viewOnly: true,
								isOutlinePane: true,
								isAssociated: this.viewOnly
							});
							this.outlinePane.set('content', this.processDescriptionTreePane); //$NON-NLS-1$
							var navData = new NavigationData({
								isOutlineData: true,
								eTag: eTag,
								xmlData: data,
								urlToXmlMap: urlToXmlMap
							});
							var jsonData = navData.getJsonData();
							var tree = this.createTree(jsonData, this.processDescriptionTreePane, true, false);
							this.processDescriptionTreePane.addPracticeTree(tree);
						}));
					}
				}),
				error: dojo.hitch(this, function() {
				
				})
			});
		},
        
		getTreeIndex: function(url) {
			for (var i = 0; i < this.workingCopy.processDescription.model.practiceList.length; i++) {
				var practiceUrl = this.workingCopy.processDescription.model.practiceList[i].url;
				if (practiceUrl === url) {
					return i;
				}
			}
		},
		
		buildPlainPracticeTree: function (practiceInfo, treeContainer, isShared, showArchived){
			if (showArchived !== true && practiceInfo.isArchived === true) {
				// do not build this archived practice tree 
				// if archived items are not allowed to show
				return;
			}
			var id = UIHelper.getResourceId(practiceInfo.url);
			var currentLanguage = this.workingCopy.currentLanguage;
			var languagesObject = {};
			languagesObject[currentLanguage] = {};
			languagesObject[currentLanguage].ETag = "";  //$NON-NLS-1$
			languagesObject[currentLanguage].textContent = {};
			languagesObject[currentLanguage].basicInformation = {};
			languagesObject[currentLanguage].basicInformation.label = practiceInfo.title;
			languagesObject[currentLanguage].basicInformation.description = ""; //$NON-NLS-1$
			var model = {};
			model.ETag = ""; //$NON-NLS-1$
			model.structure = UIHelper.getEmptyPresentation();
			var practiceJsonData = {
				identifier: 'id', //$NON-NLS-1$
				label: 'label', //$NON-NLS-1$
				resource: practiceInfo.url,
				id: id,
				title: practiceInfo.title,
				practiceId: id,
				model: model,
				languages: languagesObject,
				attachmentsUrl: null,
				defaultLanguage: currentLanguage,
				isArchived: practiceInfo.isArchived,
				items: []
			};
			
			if (isShared) {
				practiceJsonData.isShared = true;
			}
			this.workingCopy.addPractice(dojo.clone(practiceJsonData));
			var tree = this.createTree(practiceJsonData, treeContainer, false, isShared);
			tree.indexInParent = this.getTreeIndex(tree.practiceResource);
			treeContainer.addPracticeTree(tree);
		},
		
		buildPracticeTree: function(data, treeContainer, isShared) {
			var doc = UIHelper.parseXmlTextToDOMDocument(data.body);
			var practiceETag = data.etag;
			var practiceJsonData = this.convertXMLtoJsonData(doc, practiceETag);
			if (isShared) {
				practiceJsonData.isShared = true;
			}
			
			var index = this.workingCopy.getIndexofPractice(practiceJsonData.resource);
			if(index != -1){
				// replace the plain practice in working copy
				this.workingCopy.practiceList.splice(index, 1, dojo.clone(practiceJsonData));
			} else {
				this.workingCopy.addPractice(dojo.clone(practiceJsonData));
			}
			
			var tree = this.createTree(practiceJsonData, treeContainer, false, isShared);
			tree.indexInParent = this.getTreeIndex(tree.practiceResource);
			if (treeContainer.exist(tree.practiceResource)) {
				// remove the old tree in treeContainer
				treeContainer.removePracticeTree(tree.practiceResource);
			}
			treeContainer.addPracticeTree(tree);			
		},
		
		fetchPracticeTree: function(url, treeContainer, isShared, callback) {
			ProcessAuthoringClient.getPractice({
				lastModified: this.workingCopy.lastModified,
				url: url + "?lang=" + this.workingCopy.currentLanguage, //$NON-NLS-1$
				load: dojo.hitch(this, function(data, ioArgs) {
					var practiceETag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
					var practiceJsonData = this.convertXMLtoJsonData(data, practiceETag);
					if (isShared) {
						practiceJsonData.isShared = true;
					}
					
					var index = this.workingCopy.getIndexofPractice(practiceJsonData.resource);
					if (index != -1) {
						// replace the plain practice in working copy
						this.workingCopy.practiceList.splice(index, 1, dojo.clone(practiceJsonData));
					} else {
						this.workingCopy.addPractice(dojo.clone(practiceJsonData));
					}
					var tree = this.createTree(practiceJsonData, treeContainer, false, isShared);
					tree.indexInParent = this.getTreeIndex(tree.practiceResource);
					if (treeContainer.exist(tree.practiceResource)) {
						// remove old tree in treeContainer
						treeContainer.removePracticeTree(tree.practiceResource);
					}
					treeContainer.addPracticeTree(tree);
					if (dojo.isFunction(callback)) {
						callback();
					}
				}),
				error: dojo.hitch(this, function(error, ioArgs) {
					var licenseWarning = UIHelper.getLicenseWarning(ioArgs);
					if (error.responseText && error.status == ProcessAuthoringConstants.SC_FORBIDDEN && licenseWarning) {
						error.message = error.responseText;
						error.headerMessage = this.messages.ProcessDescriptionEditor_1;
						this.displayWarningMessage(error, false);
					} else {
						this.displayErrorMessage(error);
					}
				})
			});
		},
		
		reload: function() {
			var basicInformation = this.workingCopy.getProcessDescriptionBasicInformationForCurrentLangugage();
			this.detailEditor.setDescription(basicInformation.description);
			this.detailEditor.setLanguage(this.getFullLanguage(this.workingCopy.currentLanguage));
			this.detailEditor.defaultField.checked = this._isDefaultLanguage();
			this.name.value = basicInformation.label;
			this.processDescriptionLanguage = this.workingCopy.currentLanguage;
			this.processDescriptionName = basicInformation.label;
			this.processDescription = basicInformation.description;

			this.togglePrimaryField(ProcessAuthoringConstants.EditorMode.PREVIEW);
			this.initializedContentEditor = false;
			
			this.practiceTreePane.removePracticeTrees();
			dojo.forEach(this.workingCopy.practiceList, function(practice) {
				if (practice.isShared && !this.workingCopy.sharedSupport) {
					return;
				}
				this.workingCopy.getTreeJsonArray(practice, dojo.hitch(this, function(treeData) {
					var tree = this.createTree(treeData, this.practiceTreePane, false, practice.isShared);
					tree.indexInParent = this.getTreeIndex(tree.practiceResource);
					this.practiceTreePane.addPracticeTree(tree);
					this.openCurrentItem(this.practiceTreePane, practice.isShared ? true : false);
				}), true);
			}, this);
			dojo.publish(ProcessAuthoringConstants.PUBLISHTYPE_PRACTICES_LOAD_DONE);
		}
	});
})();
