/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	
	'reports': "Reports",
	'listOfResources': "Resources",
	
	// Reports View
	'sharedReports': "Shared Reports",
	'myReports': "My Reports",
	'reportTemplates': "Report Resources",
	'createReport': "Create Report",
	'createReportFromTemplate': "Create Report from Resource",
	'runningReports' : "Running Reports",
	'reportColon': "Report: ",
	'report': "Report",
	'newReport': "New Report",
	'importReport': "Import Custom Report",
	'moveReport': "Move/Copy Report",
	'moveFolder': "Move/Copy Folder",
	
	// Report Viewer
	'run': "Run",
	'refresh': "Refresh",
	'loading': "Loading...",
	'loadingReport': "Loading Report",
	'format': "Format: ",
	'parameters': "Parameters",
	'submit': "Submit",
	'save': "Save",
	'saveAs': "Save As..",
	'closeParameters': "Close Parameters",
	'saveCopy': "Save As",
	'name': "Name: ",
	'cancel': "Cancel",
	'close': "Close",
	'missingReqParam': "Missing Required Parameter: ${0}",
	'parametersTooltip': "Click to Edit Parameters",
	'exportTitle': "Export...",
	'viewInPrintableFormatTitle': "View Report in Printable Format",
	'nowDefaultReport': "This is now the default report.",
	'setAsDefaultReport': "Set as Default Report",
	'exportOperationNotSupported': "Export operation not supported for this report.",
	'msgProjectAreaIsDifferent': "The project area for this report (${0}) is different from the project area context selected for the page (${1}).",	
	'msgProjectAreaIsDifferentDetails': "The page displayed has a project area context which is selected using the drop-down selection shown in the header. " +
		"This report may display data from a different project area than indicated in the drop-down selection.",
	
	// Reports Welcome
	'welcomeGettingStarted': "To get started, view an existing report by selecting it from the left panel.",
	'welcomeToReports': "Welcome to Reports",
	'welcomeStarted1': "To get started, ",
	'welcomeStarted2': "create a new report ",
	'welcomeStarted3': "or view an existing report by selecting it from the left panel.",
	
	// Reports Additional Tasks Page
	'additionalReporting': "Perform Additional Reporting Tasks",
	'customizeReportStudio': "Customize report definitions using Report Studio",
	'additionalTask1': "Create a new report definition or modify an existing report definition using Report Studio on the Rational Report server.",
	'customizeQueryStudio': "Customize report definitions using Query Studio",
	'additionalTask2': "Work with lightweight queries for simple reporting using Query Studio on the Rational Report server.",
	'manageResource': "Manage resource in Cognos Connection",
	'additionalTask3': "Create, organize, delete reporting resources using Cognos Connection on the Rational Report server.",
	'devIntelligence': "Perform tasks for development intelligence report resources",
	'devIntelligenceDesc_1': "Click the shortcuts on this page to access Rational Reporting for Development Intelligence tools.",
	'devIntelligenceDesc_2': "For additional information, see the help topic on ",
	'devIntelligenceLink': "Authoring development intelligence reports.",
	'documentStyle': "Perform tasks for document-style report resources",
	'documentStyleDesc_1': "To create and customize document templates, use Rational Publishing Engine's Document Studio, which must be installed on your workstation and launched outside of this application. A separate license and installation is required.",
	'documentStyleDesc_2': "For additional information, see the help topic on ",
	'documentStyleLink': "Authoring document-style reports.",
	
	// Report Parameter Messages
	'trueValue': "Yes",
	'falseValue': "No",
	'noSelection': "(No Selection)",
	'zeroSelected': "0 of 0 selected",
	'numSelected': "${0} of ${1} selected",
	'numSelectedTotal': "${0} of ${1} selected (${2})",
	'numTotal': "&nbsp;(total ${0})",
	'numItemsSelected': "(${0} items selected)",
	'loading': "Loading...",
	'selectAll': "Select All",
	'deSelectAll': "Deselect All",
	'addMoreValues': "Add more values",
	'addValuesDialogTitle': "Add Parameter Values",
	'currentIteration': 'Current Iteration',
	'myTeamAreas': 'My Team Areas',
	'currentContributor': 'Current Contributor',
	'noItemsSelected': 'No items selected',
	'browse': 'Browse',
	'noLabel': '(No label)',
	
	// List Box
	'msgLoading': "Loading...",
	
	// Admin Section
	'admin': "Admin",
	'needSnapshotSelection': "Need a snapshot selected",
	'requestSubmitted': "Request submitted.",
	'waitingForResponse': "Waiting for response.",
	'checkActiveServicesInAdminPage': "Check the Active Services in Admin Page for status.",
	'responseReceived': "Response received.",
	'lastRequestSucceeded': "Last request succeeded.",
	'errorInResponse': "Error in response.",
	'lastRequestFailed': "Last request failed.",
	'schemaDatabaseName': "Schema Database Name: ${0}",
	'schemaVersion': "Schema Version:       ${0}",
	'tableLogicalName': "Table Logical Name:",
	'tableDatabaseName': "Table Database Name:",
	'fieldLogicalName': "Field Logical Name",
	'fieldDatabaseName': "Field Database Name",
	'fieldLogicalType': "Field Logical Type",
	'fieldDatabaseType': "Field Database Type",
	'listAllTables': "List All Tables",
	'updateSnapshotData': "Update Snapshot Data",
	'updateAllSnapshotData': "Update All Snapshot Data",
	
	// New Folder Dialog
	'newFolder': "New Folder",
	'teamArea': "Project/Team Area: ",
	'ok': "OK",
	
	//Move item dialog
	'move': "Move",
	'copy': "Copy",
	
	// IncludeArchived
	'includeArchived': "Include Archived",
	'includeArchivedTooltip': "Include archived artifacts in results",
	
	// FolderWidget
	'newFolderDotDotDot': "New Folder...",
	'rename': "Rename",
	'deleteMsg': "Delete Folder", // Note: do NOT use 'delete' as it is a reserved word
	'newName': "New name:",
	'invalidNameEntered': "Invalid name entered.",
	'confirmDelFolder': "Are you sure you wish to delete this folder and all the reports in it?",
	'newFolderName': "New folder name:",
	'edit': "Edit",
	
	// ReportTemplatesNavigator
	'confirmDelTemplate': "Are you sure you wish to delete this report resource? All reports based on this resource will also be deleted.",
	'confirmDelTemplates': "Are you sure you wish to delete the ${0} selected report resources? All reports based on these resources will also be deleted.",
	'deleteTemplate': "Delete Resource",
	'editTemplate': "Edit",
	'newTemplateDotDotDot': "Create Resource...",
	'findTemplatesDotDotDot': "Deploy New Resources...",
	'refresh': "Refresh",
	'noRestore': "This resource does not have contents to be restored",
	
	// QueryWidget
	'deleteReportMsg': "Delete Report",
	'confirmDelReport': "Are you sure you wish to delete this report?",
	'confirmDelReports': "Are you sure you wish to delete the ${0} selected report(s)?",
	'confirmDelFolders': "Are you sure you wish to delete the ${0} selected folder(s). Any reports in the selected folder(s) will also be deleted?",
	'confirmDelReportsAndFolders': "Are you sure you wish to delete the ${0} selected report(s) and ${1} selected folder(s). Any reports in the selected folder(s) will also be deleted?",
	'movingReports': "Moving/Copying ${0} report(s)",
	'movingFolders': "Moving/Copying ${0} folder(s)",
	'movingReportsAndFolders': "Moving/Copying ${0} report(s) and ${1} folder(s)",
	'isNowDefaultReport': "${0} is now the default report.",
	
	// New Report Editor
	'description': "Description: ",
	'folder': "Folder: ",
	'template': "Resource: ",
	'pleaseSelectTemplate': "Please select a resource.",
	'pleaseSelectFolder': "Please select a folder.",
	
	// Error messages
	'handleSetAsDefaultError': "Error setting default report: ${0}",
	
	// Select Report Dialog
	'selectReportTemplate': "Select Report Resource",
	'selectTheReportTemplate': "Select the report resource to display",
	
	// Report Template Editor
	'reportTemplate': "Report Resource",
	'reportCustomTemplate': "Custom Report Resource",
	'availableCustomReports': "Available Custom Reports:",
	'identifier': "Identifier:",
	'source' : "Source:",
	'resources': "Files",
	'shared': "Shared",
	'supportsCaching': "Supports data caching",
	'invalidFileName': "An error occured during file upload.\nThis will happen when an invalid fully qualified file name is provided.",
	'errorUploadingFile': "Error uploading file: ${0}",
	'general': "General",
	'sharing': "Project/Team Area",
	'contents': "Contents",
	'caching': "Caching",
	'upload': "Select a local report design file to replace the contents of this resource.",
	'sharingHeader': "Select a project/team area to associate the item with. This is required even if the item is not shared with other contributors.",
	'resourcesHeader': "Manage attached files used by this report resource. Select a local file to upload.",
	'resource': "File",
	'actions': "Actions", 
	'newResource': "New File",
	'uploadNewContent': "Upload New Content",
	'clickToEdit': "Click to edit",
	'selectAResource': "Select a local file to upload.",
	'reportDescription': "${0} Report",
	'errorUnhelpful':  "An error occurred which did not produce a helpful message.",
	'restore': "This report has overridden the contents and/or files from its source.",
	'restoreInitialContents': "Restore contents from source",
	'confirmMultiRestoreInitialContents' : "Are you sure you want to restore initial contents for the ${0} selected report resources?",
	'contentsRestored': "The report resource has been restored to its initial contents.",
	'multipleContentsRestored': "The report resource(s) have been restored to their initial contents.",
	'cannotRestoreContents': "Cannot restore contents until the new report resource has been saved.",
	'planning': "Planning",
	'planningMessage': "Set this report resource as the default report shown in the planning editor.",
	'cannotSetAsPlanningReport': "Cannot set as default until the new report resource has been saved.",
	'defaultReportSet': "This report resource has been set as the default planning report.",
	'customReportServerInvalid': "Cannot reach the IBM Rational Reporting Server. Please check network connectivity and verify the server location is correct and the server is running.",
	'noCognosReportsAvailable': "There are no custom reports available on the IBM Rational Reporting Server. Create a report on the Reporting Server before creating a Custom Report Resource.",
	'missingRequiredFields': "Fill in all required fields prior to saving.",
	'loadingCustomReportTemplates': "Loading Custom Reports",
	'templateSavedSuccessfully': "Report resource saved successfully.",
	'localSourceText' : "Current project",
	
	// Deploy Templates Viewer
	'noTemplatesFound': "No new report resources were found.",
	'deployNewTemplates': "Deploy New Report Resources",
	'selectResourceHeading' : "Select resources to deploy",
	'selectSourceHeading' : "Select source to deploy from",
	'selectSourceText1' : "These resources are available from the source location but have not been deployed to the selected project or team area.",
	'selectSourceText2' : "If you make changes to the original resource, the associated resources deployed in your project or team area will be updated.",
	'selectTargetHeading' : "Select project or team area to deploy resources to",
	'selectTargetLabel' : "Project/team area",
	'deployButtonLabel' : "Deploy",
	'deployingNewTemplates': "Deploying new report resources.",
	'deploySuccess' : "You have successfully deployed the following report resources to the ${0} project or team area",
	'reportResourceLinkText' : "View report resources",
	'applicationSourceOption' : "Provided by application",
	'projectHeadingOption' : "Projects",
	
	// Folder editor
	'folderHeading': "Folder",
	
	// ReportsComponentMenu
	'allSharedReports': "All Shared Reports",
	'createReportTemplate': "Create Report Resource",
	'allHeading': "All Reports",
	'allShared': "All Shared",
	'allMine': "All Mine",
	'browse': "Browse",
	'create': "Create",
	'welcomeToReports': "Welcome to Reports",
	'customizeReport': "Customize Report",
	'performAdditional': "Perform Additional Reporting Tasks",
	'recentlyViewed': "Recently Viewed",
	'noRecentItems': "No recent items",
	'maximum': "${0}, maximum",
	
	// AllReportsTab
	'allReportsNone': "No reports found.",
	'allTemplatesNone': "No report resources found.",
	'allReportsSearching': "Searching reports",
	'createFolder': "Create Folder",
	'createNewTemplate': "Create Resource",
	'createNewTemplateFromCustomReport': "Create Resource from Custom Report",
	'deployNewTemplates': "Deploy New Resources",
	'selectView': "Select View:",
	'allFolders': "All Folders",
	'deletionSuccessful': "Report resource successfully deleted",
	'descriptioncolumnheader': "Description",
	'collapseAll': "Collapse All",
	'expandAll' : "Expand All",
	
	// New Reports Welcome
	'accessAndManage': "Access and manage your work:",
	'useTheNavigation': "Use the <b>navigation bar drop-down menu</b> to create resources or to access existing resources.",
	'searchForResources': "Search for resources with <b>quick search</b>.",
	'trackResourcesAvailable': "Track resources available from <b>navigation bar drop-down menu</b> and <a class='img-db-mini' href=\"${0}\" target=\"_blank\">Mini Dashboard</a>.",
	'showMe': "Show me >",
	'viewReports': "View reports",
	'browseYourProject': "Browse available reports to select and view a report.",
	'createAReport': "Create report from resource",
	'createAReportFrom': "Create a report from an existing resource.",
	'organizeYourReports': "Organize your reports",
	'organizeYourReportsBy': "Organize your reports by creating folders and nesting folders.",
	'performAdditionalReporting': "Perform additional reporting tasks",
	'rrdiRequired': "Rational Reporting for Development Intelligence is required to perform additional reporting tasks. Contact your Administrator.",
	'additionalReportingDescription': "Customize, author, and manage report resources.",
	'learnMoreAbout': "Learn more about reporting >",
	
	//Author Custom Reports
	'authorCustomReportsTitle' : "Author a Custom Report Resource",
	'customReportsNotInstalled' : "Rational Reporting for Development Intelligence is required to author custom report resources but is not installed or is not configured properly.",
	'customReportsNotInstalledInstructions' : "Instructions can be found on the ",
	'customReportsNotInstalledLink' : "CLM Reporting Wiki Page.",
	'customReportsNotInstalledNonAdmin' : "Contact an Administrator.",
	
	//Navigate Away with Unsaved Changes
	'navigateAway' : "Are you sure you want to navigate away from this page?",
	'unsavedChanges' : "You have unsaved changes on this page.  If you continue, you will lose your changes.",
	'okOrCancel': "Press OK to continue, or Cancel to stay on the current page."
})